// file: $USFS/class/image_analysis/v1.0/imaga_hist_09.cc
//

// isip include files
//
#include "image_analysis.h"
#include <integral_constants.h>

// method: hist_normalize_cc
//
// arguments: none
//
// return: a logical_1 value indicating status
//
// this method normalizes a histogram
//
logical_1 Image_analysis::hist_normalize_cc() {
  
  // declare a scaling constant
  //
  if (hist_t_npxls_d == (int_4)0) {
    error_handler_cc((char_1*)"hist_normalize_cc",
		     (char_1*)"no data to be normalized");
  }

  for (int_4 i=0; i<hist_nbins_d; i++) {
    fprintf(stdout, "%ld\t%f\t%f\t%f\n", i, hist_t_rpdf_d[i], hist_t_gpdf_d[i],
	    hist_t_bpdf_d[i]);
  }
  
  float_8 scale = 1.0 / (float_8)hist_t_npxls_d;
  
  // normalize
  //
  for (int_4 i=0; i<hist_nbins_d; i++) {
    
    // compute the differences
    //
    hist_t_rpdf_d[i] *= scale;
    hist_t_gpdf_d[i] *= scale;
    hist_t_bpdf_d[i] *= scale;
    
  }

  float_4 sum_r = 0.0;
  float_4 sum_g = 0.0;
  float_4 sum_b = 0.0;
  
  for (int_4 i=0; i<hist_nbins_d; i++) {
    sum_r += hist_t_rpdf_d[i] * hist_r_rcval_d[i];
    sum_g += hist_t_gpdf_d[i] * hist_r_gcval_d[i];
    sum_b += hist_t_bpdf_d[i] * hist_r_bcval_d[i];
  }

  // print the mean value of each of the color
  //
  fprintf(stdout, "%3.3f\t%3.3f\t%3.3f\t", sum_r, sum_g, sum_b);
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
